function love.load()
	
	DEBUG = true
	
	SCREEN_WIDTH = 800
	SCREEN_HEIGHT = 600
	local fullscreen = false
	local fsaa = 2
	local vsync = false
	
	-- find the max supported resolution
	local modes = love.graphics.getModes()
	table.sort(modes, function(a, b)
		return (a.width * a.height) < (b.width * b.height)
	end)
	local maxMode = modes[#modes]
	
	if not DEBUG then
	
		SCREEN_WIDTH = maxMode.width
		SCREEN_HEIGHT = maxMode.height
		
	end
	
	love.graphics.setMode(
		SCREEN_WIDTH,
		SCREEN_HEIGHT,
		fullscreen,
		vsync,
		fsaa
	)
	
	SCALE = 8

	-- lib requires
	require "lib.middleclass"
	
	-- game requires
	require "src.util.gamera"
	require "src.util.math"
	require "src.util.colors"
	require "src.game.actor"
	require "src.game.player"
	require "src.game.planet"
	require "src.game.core"
	require "src.game.block"
	require "src.game.system"
	
	system = System()
	
end

function love.update(dt)

	system:update(dt)
	
end

function love.draw()
	
	love.graphics.push()
	
	system:draw()
	
	love.graphics.pop()

end

function love.keypressed(key, unicode)

	if key == "escape" then
		love.event.quit()
	end
	
	system:keyPressed(key, unicode)

end

function love.mousepressed(x, y, button)

	

end