HCursor = class("HCursor")

function HCursor:initialize(world, camera)

	self.body = love.physics.newBody(world, love.mouse.getX(), love.mouse.getY(), "dynamic")
	self.body:setActive(true)
	self.shape = love.physics.newCircleShape(2)
	self.fixture = love.physics.newFixture(self.body, self.shape)
	self.fixture:setSensor(true)
	self.fixture:setUserData({parent = self})
	self.type = SENSOR_MOUSE

	-- needed for a position offset because of the way the camera centers
	self.camera = camera
	
end

function HCursor:update(dt)

	self.body:setPosition(
		self.camera:toWorld(love.mouse.getX(), love.mouse.getY())
		)
	
	
	
end

function HCursor:draw()

	love.graphics.circle(self.body:getX(),self.body:getY(),5)
	
end

	

function HCursor:mousePressed(x, y, button)

	if button == "l" then
		
	end

end

function HCursor:mouseReleased(x, y, button)

	if button == "l" then
		
	end

end

function HCursor:beginContact(ownFixture, objectFixture, coll)
	
end

function HCursor:endContact(ownFixture, objectFixture, coll)

end