Player = class("Player", Actor)

function Player:initialize(x, y, world, camera)

	self.onPlanet = false
	
	self.texture = love.graphics.newImage("res/player.png")
	self.texture:setFilter("nearest", "nearest")
	
	Actor.initialize(self, x, y, BLOCK_SIZE, BLOCK_SIZE * 2, world)
	self.fixture:setUserData({
		parent = self
		})
		
	self.type = PLAYER
	
	self.camera = camera
	
	self.currentAngles = {diffence = nil, bodyAngle = nil}

end

function Player:update(dt)

	if love.keyboard.isDown('a') then
		local x, y = self.body:getWorldVector(-1,0)
		self.body:applyForce(5 * x, 5 * y)
	elseif love.keyboard.isDown('d') then
		local x, y = self.body:getWorldVector(1,0)
		self.body:applyForce(5 * x, 5 * y)
	end
	
	if love.keyboard.isDown('s') then

	end

	if love.mouse.isDown("r") == true then
		
		local x,y = self.camera:toScreen(self.body:getX(), self.body:getY())
		local deltaX = love.mouse:getX() - 400
		local deltaY = love.mouse:getY() - 300
		if love.keyboard.isDown('s') then
			deltaX = love.mouse:getX() - x
			deltaY = love.mouse:getY() - y
			print("X: ".. math.round(x).. " Y: " .. math.round(y))
		end
		if self.currentAngles.difference == nil then
			self.currentAngles.difference = -math.atan2(deltaX, deltaY)
			self.currentAngles.bodyAngle = math.simpleAngle(self.body:getAngle())
		end
		self.body:setAngularVelocity(0)
		self.body:setAngle(self.currentAngles.bodyAngle - self.currentAngles.difference - math.atan2(deltaX, deltaY))
	else
		self.currentAngles = {difference = nil, bodyAngle = nil}
	
	end
		
	
		
	Actor.update(self, dt)

end

function Player:draw()

	love.graphics.draw(
		self.texture,
		self.x,
		self.y,
		self.body:getAngle(),
		1.25,
		1.15,
		self.w / 2,
		self.h / 2
	)

	--Actor.draw(self)

end

function Player:keyPressed(key, unicode)

	if unicode == 119 then
		local x, y = self.body:getWorldVector(0,-1)
		self.body:applyLinearImpulse( x, y)
	end

end

function Player:beginContact(fixture, coll)

end

function Player:endContact(fixture, coll)
    
end

function Player:preSolve(fixture, coll)
    
end

function Player:postSolve(fixture, coll)
    
end